#include "HostInfoItem.h"
HostInfoItem::HostInfoItem()
:BString(),fip(INADDR_ANY),ftime(0)
{

}
HostInfoItem::HostInfoItem(const char *hostname,uint32 ip)
:BString(hostname),fip(ip),ftime(0)
{

}
HostInfoItem::HostInfoItem(HostInfoItem& obj)
:BString(obj),fip(obj.fip),ftime(obj.ftime)
{

}

uint32 HostInfoItem::IPAddress()const
{
  return fip;
}
void HostInfoItem::IPAddress(uint32 ip)
{
  fip = ip;
}

const char *HostInfoItem::HostName()const
{
  return String();
}
void HostInfoItem::HostName(const char *hostname)
{
  BString::SetTo(hostname);
}
    
int HostInfoItem::CompareHostName(HostInfoItem& obj)const
{
  return Compare(obj);
}
int HostInfoItem::CompareHostName(const char *hostname)const
{
  return Compare(hostname);
}

time_t HostInfoItem::TimeStamp()const
{
  return ftime;
}
void HostInfoItem::TimeStamp(time_t val)
{
  ftime = val;
}
void HostInfoItem::UpdateTimeStamp()
{
  time(&ftime);
}

int HostInfoItem::CompareTimeStamp(HostInfoItem& obj)
{
  if (ftime > obj.ftime)
  return 1;
  else if (ftime < obj.ftime)
  return -1;
  return 0;
}
void HostInfoItem::SetTo(HostInfoItem& obj)
{
  HostName(obj.HostName());
  IPAddress(obj.fip);
  TimeStamp(obj.ftime);
}

HostInfoItem& HostInfoItem::operator = (HostInfoItem& obj)
{
  SetTo(obj);
  return *this;
}
