#include "InProgressItem.h"
InProgressItem::InProgressItem()
:faddr(INADDR_ANY),fhostname(NULL),fresult(0)
,fwaitsem(B_NO_MORE_SEMS),fsem(B_NO_MORE_SEMS),fwaitcount(0)
{
  // Allocate Hostname String
  fhostname = new BString();
}
InProgressItem::InProgressItem(InProgressItem& obj)
:faddr(INADDR_ANY),fhostname(NULL),fresult(0)
,fwaitsem(B_NO_MORE_SEMS),fsem(B_NO_MORE_SEMS),fwaitcount(0)
{
  // Allocate Hostname String
  fhostname = new BString();
}
InProgressItem::~InProgressItem()
{
  // Delete Hostname String Object
  if (MemOK())
  delete fhostname;
  // Delete Item Sem
  if (fsem >= B_OK)
  delete_sem(fsem);
  // Delete WaitSem
  if (fwaitsem >= B_OK)
  delete_sem(fwaitsem);
}

InProgressItem& InProgressItem::operator = (InProgressItem& obj)
{
  return *this;
}
    
bool InProgressItem::MemOK()const
{
  return (fhostname != NULL);
}
status_t InProgressItem::InitSem()
{
  if (fsem >= 0)
  return B_OK;
  
  // Create Item Semaphore
  if ((fsem = create_sem(1,NULL)) < B_OK)
  return fsem;
  
  // Create Wait Semaphore  
  if ((fwaitsem = create_sem(0,NULL)) < B_OK)
  {
    // Delete Item Semaphore
    delete_sem(fsem);
    fsem = B_NO_MORE_SEMS;
    return fwaitsem;
  }
  
  return B_OK;
}
    
uint32 InProgressItem::IPAddress()const
{
  return faddr;
}
void InProgressItem::IPAddress(uint32 addr)
{
  faddr = addr;
}

void InProgressItem::Result(status_t v_result)    
{
  fresult = v_result;
}
status_t InProgressItem::Result()const
{
  return fresult;
}
    
int InProgressItem::WaitCount()const
{
  return fwaitcount;
}
void InProgressItem::WaitCount(int value)
{
  fwaitcount = value;
}
    
void InProgressItem::HostName(const char *hostname)
{
  fhostname->SetTo(hostname);
}

const char *InProgressItem::HostName()const
{
  return fhostname->String();
}
bool InProgressItem::IsHostName(const char *str)
{
  return (fhostname->Compare(str) == 0);
}

status_t InProgressItem::AcquireItemSem()
{
  return acquire_sem(fsem);
}
status_t InProgressItem::ReleaseItemSem()
{
  return release_sem(fsem);
}
    
status_t InProgressItem::AcquireWaitSem()
{
  return acquire_sem(fwaitsem);
}
status_t InProgressItem::ReleaseWaitSem()
{
  return release_sem(fwaitsem);
}

