#ifndef INPROGRESSITEM_H
#define INPROGRESSITEM_H
#include <OS.h>
#include <String.h>
#include <netdb.h>
class InProgressItem
{
  public:
    InProgressItem();
    InProgressItem(InProgressItem&);
    virtual ~InProgressItem();
 
    InProgressItem& operator = (InProgressItem&);
    
    bool MemOK()const;
    status_t InitSem();
    
    uint32 IPAddress()const;
    void IPAddress(uint32);

    void Result(status_t);    
    status_t Result()const;
    
    int WaitCount()const;
    void WaitCount(int);
    
    void HostName(const char*);
    const char *HostName()const;
    bool IsHostName(const char *);
    
    status_t AcquireItemSem();
    status_t ReleaseItemSem();
    
    status_t AcquireWaitSem();
    status_t ReleaseWaitSem();    
  private:
    uint32   faddr;
    BString *fhostname; 
    status_t fresult;
    sem_id   fwaitsem;
    sem_id   fsem;
    int      fwaitcount;
                 
};
#endif